﻿using System;
using System.Reflection;
using Amplitude;
using Amplitude.Mercury;
using Amplitude.Mercury.Simulation;
using Amplitude.Mercury.Interop;
using Amplitude.Mercury.Sandbox;
using Amplitude.Framework.Simulation;

namespace AOM.Humankind.EraStarCatchupFame
{
    public static class R
    {

        static FieldInfo DepartmentOfDevelopment_EraStarCatchupInfo_FieldInfo = typeof(DepartmentOfDevelopment).GetField("EraStarCatchupInfo", BindingFlags.Public | BindingFlags.Instance);
        public static EraStarCatchupInfo EraStarCatchupInfo(this DepartmentOfDevelopment self)
        {
            return (EraStarCatchupInfo)DepartmentOfDevelopment_EraStarCatchupInfo_FieldInfo.GetValue(self);
        }
        public static void EraStarCatchupInfo(this DepartmentOfDevelopment self, EraStarCatchupInfo value)
        {
            DepartmentOfDevelopment_EraStarCatchupInfo_FieldInfo.SetValue(self, value);
        }
        static FieldInfo DepartmentOfDevelopment_CurrentEraIndex_FieldInfo = typeof(DepartmentOfDevelopment).GetField("CurrentEraIndex", BindingFlags.NonPublic | BindingFlags.Instance);
        public static Int32 CurrentEraIndex(this DepartmentOfDevelopment self)
        {
            return (Int32)DepartmentOfDevelopment_CurrentEraIndex_FieldInfo.GetValue(self);
        }
        public static void CurrentEraIndex(this DepartmentOfDevelopment self, Int32 value)
        {
            DepartmentOfDevelopment_CurrentEraIndex_FieldInfo.SetValue(self, value);
        }

        static MethodInfo DepartmentOfDevelopment_ComputeEraStarCatchupPointsPerTurn_MethodInfo = typeof(DepartmentOfDevelopment).GetMethod("ComputeEraStarCatchupPointsPerTurn", BindingFlags.NonPublic | BindingFlags.Instance);
        public static FixedPoint ComputeEraStarCatchupPointsPerTurn(this DepartmentOfDevelopment self)
        {
            return (FixedPoint)DepartmentOfDevelopment_ComputeEraStarCatchupPointsPerTurn_MethodInfo.Invoke(self, new object[] { });
        }

        static FieldInfo DepartmentOfDevelopment_majorEmpire_FieldInfo = typeof(DepartmentOfDevelopment).GetField("majorEmpire", BindingFlags.NonPublic | BindingFlags.Instance);
        public static MajorEmpire majorEmpire(this DepartmentOfDevelopment self)
        {
            return (MajorEmpire)DepartmentOfDevelopment_majorEmpire_FieldInfo.GetValue(self);
        }
        public static void majorEmpire(this DepartmentOfDevelopment self, MajorEmpire value)
        {
            DepartmentOfDevelopment_majorEmpire_FieldInfo.SetValue(self, value);
        }

        static MethodInfo DepartmentOfDevelopment_SetupEvolutionPeriodicNotificationIfRequired_MethodInfo = typeof(DepartmentOfDevelopment).GetMethod("SetupEvolutionPeriodicNotificationIfRequired", BindingFlags.NonPublic | BindingFlags.Instance);
        public static void SetupEvolutionPeriodicNotificationIfRequired(this DepartmentOfDevelopment self)
        {
            DepartmentOfDevelopment_SetupEvolutionPeriodicNotificationIfRequired_MethodInfo.Invoke(self, new object[] { });
        }

        static FieldInfo SandboxManager_Sandbox_FieldInfo = typeof(SandboxManager).GetField("Sandbox", BindingFlags.NonPublic | BindingFlags.Static);
        public static Sandbox SandboxManager_Sandbox()
        {
            return (Sandbox)SandboxManager_Sandbox_FieldInfo.GetValue(null);
        }
        static PropertyInfo Sandbox_Turn_PropertyInfo = typeof(Sandbox).GetProperty("Turn", BindingFlags.NonPublic | BindingFlags.Instance);
        public static Int32 Turn(this Sandbox self)
        {
            return (Int32)Sandbox_Turn_PropertyInfo.GetValue(self);
        }

        static MethodInfo DepartmentOfDevelopment_GainFame_MethodInfo_FixedPoint_Boolean = typeof(DepartmentOfDevelopment).GetMethod("GainFame", BindingFlags.NonPublic | BindingFlags.Instance, null, new Type[] { typeof(FixedPoint), typeof(Boolean) }, null);
        public static void GainFame(this DepartmentOfDevelopment self, FixedPoint gain, Boolean raiseSimulationEvents)
        {
            DepartmentOfDevelopment_GainFame_MethodInfo_FixedPoint_Boolean.Invoke(self, new object[] { gain, raiseSimulationEvents });
        }
        static PropertyInfo Empire_IsControlledByHuman_PropertyInfo = typeof(Empire).GetProperty("IsControlledByHuman", BindingFlags.Public | BindingFlags.Instance);
        public static Boolean IsControlledByHuman(this Empire self)
        {
            return (Boolean)Empire_IsControlledByHuman_PropertyInfo.GetValue(self);
        }
        public static void IsControlledByHuman(this Empire self, Boolean value)
        {
            Empire_IsControlledByHuman_PropertyInfo.SetValue(self, value);
        }

        static FieldInfo Empire_Index_FieldInfo = typeof(Empire).GetField("Index", BindingFlags.NonPublic | BindingFlags.Instance);
        public static Int32 Index(this Empire self)
        {
            return (Int32)Empire_Index_FieldInfo.GetValue(self);
        }
        public static void Index(this Empire self, Int32 value)
        {
            Empire_Index_FieldInfo.SetValue(self, value);
        }
        static FieldInfo MajorEmpire_PersonaName_FieldInfo = typeof(MajorEmpire).GetField("PersonaName", BindingFlags.NonPublic | BindingFlags.Instance);
        public static string PersonaName(this MajorEmpire self)
        {
            return (string)MajorEmpire_PersonaName_FieldInfo.GetValue(self);
        }
        public static void PersonaName(this MajorEmpire self, string value)
        {
            MajorEmpire_PersonaName_FieldInfo.SetValue(self, value);
        }

        static FieldInfo Empire_PlayerIdentifier_FieldInfo = typeof(Empire).GetField("PlayerIdentifier", BindingFlags.NonPublic | BindingFlags.Instance);
        public static PlayerIdentifier PlayerIdentifier(this Empire self)
        {
            return (PlayerIdentifier)Empire_PlayerIdentifier_FieldInfo.GetValue(self);
        }
        public static void PlayerIdentifier(this Empire self, PlayerIdentifier value)
        {
            Empire_PlayerIdentifier_FieldInfo.SetValue(self, value);
        }
        static FieldInfo MajorEmpire_FameScore_FieldInfo = typeof(MajorEmpire).GetField("FameScore", BindingFlags.Public | BindingFlags.Instance);
        public static EditableProperty FameScore(this MajorEmpire self)
        {
            return (EditableProperty)MajorEmpire_FameScore_FieldInfo.GetValue(self);
        }

    }
}
